<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Arrow functions</title>
    <script src="cities.js"></script>
</head>
<body>
    <script>
        // Kõik linnad
        console.log('Kõik linnad', cities)

        // [].filter() - tagasta mulle list elementidest, mis kvalifitseeruvad.
        // Kriteeriumi alusel elementide leidmine.
        let bigCities = cities.filter(c => c.population > 100000);
        console.log('Suured linnad', bigCities);

        // [].find() - tagasta mulle esimene element, mis kvalifitseerub
        let stockholm = cities.find(x => x.name == 'Stockholm');
        console.log('Stockholm', stockholm);

        // [].every() - kas vastab tõele, et kõik elemendid kvalifitseeruvad
        let allCitiesAreBig = cities.every(city => city.population > 100000);
        console.log('Kas kõik linnad suured?', allCitiesAreBig);
        let allCitiesHabitated = cities.every(city => city.population > 0);
        console.log('Kas kõigis linnades elatakse?', allCitiesHabitated);

        // [].some() - kas leidub vähemalt üks, mis kvalifitseerub?
        let atLeastOneEstonianCity = cities.some(c => c.country == 'Estonia');
        console.log('Kas vähemalt üks Eesti linn olemas?', atLeastOneEstonianCity);

        // [].map() - vii iga massiivi element teisele kujule.
        let citiesBriefly = cities.map(city => city.name + " (" + city.country + ")");
        console.log('Linnad ülevaatlikult', citiesBriefly);

        // [].forEach() - tee iga elemendiga massiivist midagi.
        // Massiivi ennast ei muudeta, midagi ei tagastata.
        cities.forEach(city => console.log(city.population));

        // // [].sort() - sorteeri elemendid kriteeriumi alusel.
        let sortedCities = cities.sort((c1, c2) => c1.name.localeCompare(c2.name));
        console.log('Tähestiku järgi sorteeritud linnad', cities);

    </script>
</body>
</html>